// 信州 / Shinshu
// Oh!X 1988/6より
// それをCに移植した物を再度X-BASIC'に移植
// v3.2 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

// ゲーム自体は日英対応だけど、コメントは多くが日本のみ / Game itself is Japanese-English correspondence. But many comments are japanese.
int fpageTest=NO

int	OFST_X=0	:// パイ表示を開始するx座標
int	OFST_Y=64	:// パイ表示を開始するy座標;これを変更するときはGameClear()の表示座標も変更すること

switch deviceType()
	case 2: // iPod touch
	case 3: // iPhone
	case 4: // iPhone Simulator
		// ちょとだけiPhone/iPod touch対応・・・しようとした
		OFST_X=0
		OFST_Y=32
		break
endswitch

enum
	// 牌の種類
	TYPES=34
	// 全牌数
	ALLPAI=(TYPES*4):// 実際に配置される牌の総数;各牌が2セット(4枚)
	// マス幅
	oX	 =2
	DANXE=12
	DANX =DANXE+oX	:// x方向にoX分は表示位置をずらすために空きになっている(表示上は使われていない)
	DANY =8
	DANXY=DANXE*DANY:// 1階層のマス数
	// 1階層の平面はDANXYマス
	DANZ =4			:// それが4階層
	ALLMASU  =DANXY*DANZ:// 全マス数；実際に牌が配置されるのはこの中の一部
	//
	// 牌の大きさ / size of PAI
	PAI_WX=48	:// スプライトでカーソルを作るため、16dot単位にすること
	PAI_WY=64
	PAI_HY=8	:// パイの高さ
	FNTSZ =28
	//
	// 取得済みの印
	FGET=100	:// >=TYPES
	// キーコード
	EXITKEY ='!':// 終了
	RETRYKEY='R':// 面やり直し
	// checkPoint()のリターン値
	RET_CHECK_EXIT=1
	RET_CHECK_RETRY
	RET_CHECK_AREA_OUT
	RET_CHECK_AREA_IN
	// カーソルに使うスプライトパターン番号
	SPPTN=1
endenum
//

// X-BASICではdim(最大要素番号)
int page=0
dim char ch(TYPES-1)
dim char pai(DANX,DANY,DANZ):// 全領域(未使用領域も含む)
dim char pai1(ALLMASU-1),pais(ALLMASU-1):// 全体を通し番号で管理するため
// 牌の配置テーブル
dim char pai2(DANY*DANZ*2)={
	// 第1層 / The first layer
    3, 6, 	// xの開始位置,牌を置く個数		それがY別
    2, 8,
    1,10, 
    0,12, 
    0,12, 
    1,10,
    2, 8, 
    3, 6, 
	// 第2層 / The second layer
    6, 0, 
    3, 6, 
    3, 6, 
    2, 8, 
    2, 8, 
    3, 6, 
    3, 6, 
    6, 0, 
	// 第3層 / The third layer
    6, 0, 
    6, 0, 
    4, 4, 
    4, 4, 
    4, 4, 
    4, 4, 
    6, 0, 
    6, 0, 
	// 第4層 / The fourth layer
    6, 0, 
    6, 0, 
    5, 2, 
    5, 2,
    5, 2, 
    5, 2, 
    6, 0, 
    6, 0
}

width(0)
int gwx,gwy
getWidth(gwx,gwy):// グラフィックモードで画面幅を取得 / Get screen width by graphics mode

font("Migu-1M-Regular",16)
width(64)
vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_SPAGE+B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3):// gpageは下からGPAGE3〜GPAGE0:上
//gAntiAlias(NO)
beep2(13,YES)
setTouchArea(0,0,0,0,0,YES):// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
initCursorSprite():// スプライト初期化

int x,y,z
int x0,y0,z0
int x1,y1,z1
int	men,c
int i,j,k
int ky

//--------

dim str menues(1)
str title$
if isLocalizeJapan() then {
	menues={"順番","ランダム"}
	title$="順番選択"
} else {
	menues={"Order","Random"}
	title$="Select order"
}
switch selectMenu(title$,menues)
	case 0:// 順番
		srand(2)
		break
	case 1:// ランダム
		srand2()
		break
endswitch
//
// 初期化
locate(0,0):print localizedString("初期化1中...":"Initialize 1...")
// pai()の設定 : 牌を取ったかどうか
for i=0 to DANX
	for j=0 to DANY
		for k=0 to DANZ
			pai(i,j,k)=FGET
		next
	next
next
// オリジナルはここでタイトルを表示する
// pais()の設定 : 牌を置ける場所には1を入れておく
c=0
for i=0 to DANY*DANZ-1
	c=c+pai2(i*2):// 全体での位置
	for j=1 to pai2(i*2+1):// 牌を並べる個数
		pais(c)=1
		c=c+1:// 隣へ
	next
	c=c+pai2(i*2)
next
locate(0,0):print chr$(DISP_CTRL_CLEARLINE);:// 初期化1終了
// 全体ループ
men=1
repeat
	// for test
	//	for i=GPAGE0 to GPAGE3
	//		apage(i)
	//		wipe()
	//	next

	// 配牌
	locate(0,0):print localizedString("配牌中...":"Distribution of pai")
	haipai()
	locate(0,0):print chr$(DISP_CTRL_CLEARLINE);:// 配牌終了
	//
	// 1面内ループ
	repeat
		cls()
		apage(GPAGE3)
		gcolor(rgb(6,119,3)):fill(0,0,gwx,gwy)
		// 全グラフィックページのクリア
		for i=GPAGE0 to GPAGE2
			apage(i)
			wipe()
		next
		setExitKey()
		sp_disp(YES):// スプライト画面表示
		//
		for x=0 to DANXE-1
			for y=0 to DANY-1
				for z=0 to DANZ-1
					pai(x+1,y,z)=pai1(x+y*DANXE+z*DANXY)
				next
			next
		next
		// 牌の表示
		for x=0 to DANXE-1
			for y=0 to DANY-1
				for z=0 to DANZ-1
					paiput(x+oX,y,z,pai(x+1,y,z))
				next
			next
		next
		// 1セットループ
		c=ALLPAI:// 初期残り枚数 / left tiles
		repeat
			sp_off()
			if isLocalizeJapan() then {
				locate(0,0):print "第";men;"面 / のこり:";c;" "
			} else {
				locate(0,0):print "Stage ";men;" / Left:";c;" "
			}

			// タッチされるのを待つ / wait touching
			if checkPoint()<>RET_CHECK_AREA_IN then continue
			x=x0:y=y0:z=z0
			
			// 押された場所にスプライトでカーソルを表示する / display sprite cursor at touched position
			cursorSprite(x,y,z):// 位置設定 / set position
			sp_on():// 表示 / display

			// タッチされるのを待つ / wait touching
			if checkPoint()<>RET_CHECK_AREA_IN then continue
			x1=x0:y1=y0:z1=z0
			
			if x=x1 and y=y1 and z=z1 then continue:// 同じ座標だった
			if pai(x  ,y ,z )<>FGET and pai(x +2,y ,z )<>FGET then continue
			if pai(x1 ,y1,z1)<>FGET and pai(x1+2,y1,z1)<>FGET then continue
			if pai(x+1,y ,z )<>pai(x1+1,y1,z1) then continue
			//
			// 1セットの牌の取得
			beep2(13)
			c=c-2:// 1セットなので2枚
			pai(x +1,y ,z )=FGET
			pai(x1+1,y1,z1)=FGET
			erasePai(x ,y ,z )
			erasePai(x1,y1,z1)
//			locate(45,0):print " x=";x ;"/ y=";y ;" z=";z
//			locate(45,1):print "x1=";x1;"/y1=";y1;"z1=";z1
		until c=0 or ky=EXITKEY or ky=RETRYKEY:// 1セットループ
		sp_off()
		sp_disp(NO)
	until c=0 or ky=EXITKEY:// 1面ループ
	if ky<>EXITKEY then {
		GameClear()
		ky=hitKey2()
		men=men+1
	}
until ky=EXITKEY:// 全体ループ
beep()
end

/***************************/

func int test(x;int,n;int,j;int)
// x=入れる予定の場所
// n=入れる牌の番号
// j=1セットの内どちらか(0/1)
// リターン値 : NO=そこは置けない , YES=置ける
//locate(0,33):print using "test(###_,###_,###)",x,n,j
	//
	if pais(x)=0     then return(NO):// 置ける場所ではない
	if pai1(x)<>FGET then return(NO):// すでに置かれている場所である
	if j=1 then {:// ペア側でのみチェック
		if pai1(x+1)=n or pai1(x-1)=n then return(NO):// 横隣が同牌なら置けない
	}
	//
	x1=x mod DANXE:// 1行内での位置
	if x>=DANXY then {:// 2階層目以降
		if j=1 and pai1(x-DANXY)=n    then return(NO):// ペア側の時、上下で重なるときは置けない
		if         pai1(x-DANXY)=FGET then return(NO):// 下が空いてる時は置けない
	}
	if x1=DANXE/2 then return(YES):// 真ん中なら置ける
	if x1<>0 and x1<>DANXE-1 then {:// 両端でない
		if pai1(x+1)<>FGET or pai1(x-1)<>FGET then {
			// 左右どちらにすでに置かれているところは置ける
			return(YES)
		} else {
			// 左右とも置かれてしまっているところはダメ
			return(NO)
		}
	}
	if x1=DANXE-1 then {:// 右端
		if pai1(x-1)=FGET then return(NO):// 左隣が開いてるなら置けない
	}
	if x1=0 then {:// 左端
		if pai1(x+1)=FGET then return(NO):// 右隣が開いてるなら置けない
	}
	// 上記どれにも当てはまらないなら置ける
	return(YES)
endfunc

/***************************/

func haipai()
// 初期牌設定(make)
	locate(0,40):print " "
	int i
	// pai1()のとりあえずの初期化
	for i=0 to ALLMASU-1
		pai1(i)=FGET
	next
	//
	int j,x,n
	for i=0 to TYPES-1
		n=(TYPES-1)-i:// 設定する牌の番号
		for j=0 to 1:// 1セット2枚だから
			x=rand2(ALLMASU)
			if test(x,n,j)=NO then {
				j=j-1:// もう一度jループをやり直すため
				continue
			}
			pai1(x)=n:// ここに設定
		next
	next
	//
//	locate(0,1):print "haipai2中..."
//	print "pai1()=";:// pais()は問題無さそう
//	for i=0 to ALLMASU-1
//		print pai1(i);
//	next
//	print
	// 再補正
	for i=0 to TYPES-1
		for j=0 to 1
			x=rand2(ALLMASU)
			int x0=x
//			locate(0,32):print "test中..."
			// 何故かここで無限ループに入ることがあるので1周したら強制終了するようにした
			while test(x,i,j)=NO
				x=(x+1) mod ALLMASU
				if x=x0 then {
//					locate(0,34):print "1周したので中断"
//					hitKey2()
					// これは解けないかもしれない
					locate(0,40):print "*":// その印を表示しておく
					break:// 1周したら止める
				}
			endwhile
//			locate(0,32):print chr$(DISP_CTRL_CLEARLINE);
			pai1(x)=i
		next
	next
//	locate(0,1):print chr$(DISP_CTRL_CLEARLINE);
	//
	// 一旦牌を順に入れる
	for i=0 to TYPES-1
		ch(i)=i
	next
	// それをランダムに入れ替え
	int a,b,c
	for i=1 to 100
		a=rand2(TYPES)
		b=rand2(TYPES)
		c=ch(a)
		ch(a)=ch(b)
		ch(b)=c
	next
	// pai1()を牌の番号に変換
	for i=0 to ALLMASU-1
		if pai1(i)<>FGET then pai1(i)=ch(pai1(i))
	next
endfunc

/***************************/

func int checkPoint()
// -> x0,y0,z0(グローバル変数)
// リターン値 : YES=continue
int x,y,z
dim float tpoint(2)
int touchCnt
	// タッチされるのを待つ & ついでに終了キーも待つ
	while getTouchStatus()=TOUCH_NONE
		ky=inkey()
		switch ky
			case EXITKEY: return(RET_CHECK_EXIT)
			case RETRYKEY:return(RET_CHECK_RETRY)
			case 'p': // fpageTest=YESでないと来ない
				page=page+1:if page>4 then page=0
				locate(0,1):print "page=";page;
				beep2(10)
				switch page
					case 0:
						vpage(B_SPAGE+B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
						break
					case 1:
						vpage(B_TPAGE+B_GPAGE0)
						break
					case 2:
						vpage(B_TPAGE+B_GPAGE1)
						break
					case 3:
						vpage(B_TPAGE+B_GPAGE2)
						break
					case 4:
						vpage(B_TPAGE+B_GPAGE3)
						break
				endswitch
				print localizedString("現在設定=":"Current setting=");right$("00000000"+bin$(vpage(-1)),8)
				break
		endswitch
	endwhile
	touchCnt=getTouchPoint(tpoint)

	// タッチが離されるのを待つ & ついでに終了キーも待つ
	while getTouchStatus()<>TOUCH_NONE
		touchCnt=getTouchPoint(tpoint)
		ky=inkey()
		switch ky
			case EXITKEY: return(RET_CHECK_EXIT)
			case RETRYKEY:return(RET_CHECK_RETRY)
		endswitch
	endwhile

	// タッチ座標から牌位置を算出
	// 実は牌の表示座標はz方向でずれるが、そこまで考慮していない
	// なので、牌の端っこあたりでは判定を間違えることがある
	// 面倒なのでとりあえず今のバージョンではそのまま
	float gx=calcX(0,0)
	float gy=calcY(0,0)
	x=(tpoint(0)-gx)/PAI_WX:// float → int
	y=(tpoint(1)-gy)/PAI_WY
//	locate(0,30):print "x=";x;",y=";y;
	if x<oX or x>DANX-1 or y<0 or y>DANY-1 then {:// 範囲外
//		print "範囲外"
		return(RET_CHECK_AREA_OUT)
	}
//	locate(0,31):print "x=";x;",y=";y;
	
	// z方向の判定
	// 重なっている牌があれば、上の牌と判定する
	// 簡易にz方向のズレも判定している
	int i
	x=x-oX
	for i=1 to DANZ
		z=DANZ-i
		if pai(x+1,y,z)<>FGET then {
			// そこは可能性あり
//			locate(0,21):print x+1;",";y+1;",";z
			if z>0 and y<DANY-1 then {
				if pai(x+1,y+1,z)<>FGET then {
					// 1つ下も存在するときはそちらの可能性もある
					// 最下層はずれないので上の層のみ
					gx=calcX(x+oX,z)
					gy=calcY(y+1 ,z)
	//				locate(0,22):print "gx,gy=";gx;",";gy
	//				locate(0,23):print "tp=";tpoint(0);",";tpoint(1)

					if tpoint(0)>=gx and tpoint(0)<gx+PAI_WX and tpoint(1)>=gy and tpoint(1)<gy+PAI_WY then {
						// 実は1つ下の牌だった
						y=y+1
					}
				}
			}
			// リターン値設定(グローバル変数経由)
			x0=x:y0=y:z0=z
//			print "z=";z;
			return(RET_CHECK_AREA_IN)
		}
	next
	return(RET_CHECK_AREA_OUT)
endfunc

/***************************/

func float calcX(x;int,z;int)
	// 高さに従って若干ずらす(これで立体感を出す)
	// Shifted slightly according to height (To give a three-dimensional impression)
	return(x*PAI_WX-z*2+OFST_X)
endfunc

func float calcY(y;int,z;int)
	// 高さに従って若干ずらす(これで立体感を出す)
	// Shifted slightly according to height (To give a three-dimensional impression)
	return(y*PAI_WY-z*PAI_HY+OFST_Y)
endfunc

/***************************/

func erasePai(x;int,y;int,z;int)
// 牌を消す / erase pai
	float gx=calcX(x+oX,z)
	float gy=calcY(y   ,z)
	float ex=gx+PAI_WX-1

	apage(GPAGE3-z)

	int col
	if z>0 then {
		col=0:// 透明色 / Transparent color
		blend(BlendModeClear)
	} else {
		// 最下層 / Bottom
		col=rgb(6,119,3):// 下地色で消す
		blend(BlendModeNormal)
	}
	gcolor(col)
	fill(gx,gy,ex,gy+PAI_WY-1)
	blend(BlendModeNormal)
	//
	if y>=1 then {
		// 最上行以外 / Other than top line
		if pai(x+1,y-1,z)<>FGET then {
			// 1つ上の分の高さを再描画する
			paiHeightPut(x+oX,y-1,z)
		}
	}
	// X68と違いiOSでは最下行も画面内なので消しが必要
	//locate(0,25):print "x+1=";x+1,"y+1=";y+1,"z=";z
	if pai(x+1,y+1,z)=FGET then {
		// 1つ下がすでに開いているときは高さ分を消す
		gy=gy+PAI_WY
		if col=0 then blend(BlendModeClear)
		gcolor(col)
		fill(gx,gy,ex,gy+PAI_HY-1)
	}
	blend(BlendModeNormal)
endfunc

/***************************/

func paiHeightPut(x;int,y;int,z;int)
// 牌の高さ方向の描画(paiput1)
// z=0～2(3段重ねだから):それをグラフィックの各ページに描画する
	apage(GPAGE3-z)
	float gx=calcX(x  ,z)
	float gy=calcY(y+1,z):// 1つ下の牌の位置
	float ex=gx+PAI_WX-1
	float ey=gy+PAI_HY-1
	// 1つ下の牌の位置からに高さを描画する
	// (1)そこを塗る
	gcolor(200,200,200,255)
	fill(gx,gy  		,ex,ey)
	// (2)その下半分を濃く塗る
	gcolor(119,119,0,255)
	fill(gx,gy+PAI_HY/2	,ex,ey)
	// 縦線描画
	gcolor(231,231,231,255)
//	line(gx,gy,gx,ey):// 左側 ← なぜかこれが残ってしまうので封印
	line(ex,gy,ex,ey):// 右側
	// なぜか指定した座標より外側にはみ出ることがある(アンチエリアシングではない)
endfunc

/***************************/

func paiput(x;int,y;int,z;int,n;int)
// 牌種類別表示 / Display pai
// n=0〜TYPES-1
// z=0～2(3段重ねだから):それをグラフィックの各ページに描画する
dim str pai0$(3)={		//			n/9		n1=n mod 9
	 "一二三四五六七八九"	// 0〜8		0		0〜8
	,"１２３４５６７８９"	// 9〜17		1		〃
	,"ＡＢＣＤＥＦＧＨＩ"	// 18〜26	2		〃
	,"東西南北　発中"		// 27〜33	3		0〜6
}
dim int col(6):// 東西南北群の色コード
	if n=FGET then return:// 取得済み牌は描画対象外

	col(0)=rgb(74,74,74,255)
	col(1)=col(0)
	col(2)=col(0)
	col(3)=col(0)
	col(4)=rgb(255,255,255,255)
	col(5)=rgb(0,0,255,255)
	col(6)=rgb(255,0,0,255)
	//
	// 下地描画
	paiHeightPut(x,y,z):// 牌の高さの表示
	apage(GPAGE3-z)
	float gx=calcX(x,z)
	float gy=calcY(y,z)
	float ex=gx+PAI_WX-1
	float ey=gy+PAI_WY-1
	gcolor(CTHWHITE)
	fill(gx  ,gy  ,ex  ,ey  ):// 下地
	gcolor(col(0))
	box( gx+2,gy+2,ex-2,ey-2):// 内枠
	//
	// 牌の種類をpai()に従って分類
	int n1=n mod 9
	n=n/9
	//
	str font$="Hiragino Mincho ProN"
	str p$   =utf8Mid$(pai0$(n),n1+1,1):// UTF8なので文字単位で操作
	
	int fntsz=FNTSZ
	if n=3 then fntsz=PAI_WX-4:// 1文字の時はフォントを大きくする
	int ox=(PAI_WX-fntsz)/2
	int oy=(PAI_WY-fntsz*2)/2
	gx=gx+ox
	int gy2=gy+PAI_WY-oy-fntsz :// 2段目文字のy位置
	int gcy=gy+(PAI_WY-fntsz)/2:// センタリング表示時のy位置
	gy=gy+oy
	switch n
		case 0
			gcolor(CTBLACK):symbol(gx,gy ,p$  ,font$,fntsz)
			gcolor(CTHRED) :symbol(gx,gy2,"萬",font$,fntsz)
			break
		case 1
			gcolor(CTHBLUE) :symbol(gx,gy ,p$ ,font$,fntsz)
			gcolor(CTHGREEN):symbol(gx,gy2,"竹",font$,fntsz)
			break
		case 2
			gcolor(CTHRED)		 :symbol(gx,gy ,p$ ,font$,fntsz)
			gcolor(119,119,0,255):symbol(gx,gy2,"◎",font$,fntsz)
			break
		case 3
			gcolor(col(n1)):symbol(gx,gcy,p$,font$,fntsz)
			break
	endswitch
endfunc

/***************************/

func cursorSprite(x;int,y;int,z;int)
// カーソル用スプライトの表示 / display cursor sprite
	sp_halt(YES):// 高速化のため / for speed up
	// スプライトの座標はint / sprite coordinate is int
	int gx=calcX(x+oX,z)
	int gy=calcY(y   ,z)
	int i,sp=1
	x=gx
	for i=1 to PAI_WX/16
		// 上 / upside
		sp_move(sp,x,gy,SPPTN):// プレーン,座標,パターンコード / plane,coordinate,pattern code
		sp=sp+1
		x=x+16
	next
	//
	gy=gy+PAI_WY-16
	x=gx
	for i=1 to PAI_WX/16
		// 下 / downside
		sp_move(sp,x,gy,SPPTN):// プレーン,座標,パターンコード / plane,coordinate,pattern code
		sp=sp+1
		x=x+16
	next
	sp_halt(NO)
	beep2(13)
endfunc

/***************************/

func initCursorSprite()
// カーソル用スプライトの初期設定
// Initialize cursor sprite
dim char sp1(16*16-1):// charなのでX68型 / X68 type because of char
	sp_clr()
	for i=0 to 16*16-1
		sp1(i  )=1:// これはパレットコード / this is palette code
		sp1(i+1)=0:// これはパレットコード / this is palette code
		i=i+1
	next
	sp_color(0,rgb(0,0,128,80))
	sp_color(1,rgb(0,0,  0,0 ))
	sp_def(SPPTN,sp1):// パターンSPPTNに登録 / set to pattern #SPPTN
endfunc

/***************************/

func GameClear()
// ゲームクリアの画面表示 / display game clear screen
	cls()
	int w=256
	float gx=(gwx-w)/2
	float gy=calcY(2,0)
	apage(GPAGE0):// 一番上の画面に表示
	gcolor(CTMAGENTA):symbol(gx  ,gy  ,"龍","Hiragino Mincho ProN",w)
	gcolor(CTHYELLOW):symbol(gx+4,gy+4,"龍","Hiragino Mincho ProN",w)
	locate(0,0):prints("　　　Ｇｏｔｏ　ｎｅｘｔ　ｓｔａｇｅ！　　　")
	str mes$
	if isLocalizeJapan() then {
		mes$="　健康のため、ゲームのやりすぎに注意しましょう。"
	} else {
		mes$=" For health, you must not overdo the game."
	}
	locate(0,1):prints(mes$)
endfunc

/******************************************************************/
/* 汎用関数 / general functions
/******************************************************************/

func int hitKey2()
	str exit$
	exit$=localizedString("次の面へ","Goto Next Stage")
	setFunctionKey(0,exit$,'n')
	if isLocalizeJapan() then {
		exit$="終了"
	} else {
		exit$="end"
	}
	setFunctionKey(1,exit$,EXITKEY)
	kBackgroundAlpha(0.7)
	displayFunctionKey(YES,0,1)
	int ky
	repeat
		ky=inkey()
	until ky<>0
	displayFunctionKey(NO,0,1)
	return(ky)
endfunc

func setExitKey()
	int keyno=1:// 0,1
	str exit$,retry$
	if isLocalizeJapan() then {
		exit$="中断":retry$="やり直し"
	} else {
		exit$="exit":retry$="Retry"
	}
	setFunctionKey(0,exit$ ,EXITKEY)
	setFunctionKey(1,retry$,RETRYKEY)
	kBackgroundAlpha(0.7)
	//
	if fpageTest then {
		setFunctionKey(2,"page",'p')
		keyno=keyno+1
	}
	displayFunctionKey(YES,0,keyno)
endfunc

/******************************************************************/
